- NAME
- SYNOPSIS
- DESCRIPTION
- COMMAND SUMMARY

- Standard Commands
- Message Digest Commands
- Encryption, Decryption, and Encoding Commands

- OPTIONS

- Common Options
- Format Options
- Pass Phrase Options
- Trusted Certificate Options
- Random State Options
- Extended Verification Options
- Verification Options
- Name Format Options
- TLS Version Options
- Engine Options

- ENVIRONMENT
- SEE ALSO
- HISTORY
- COPYRIGHT

# NAME

openssl - OpenSSL command line tool

# SYNOPSIS

openssl command [ options ... ] [ parameters ... ]

openssl list -standard-commands | -digest-commands | -cipher-commands | -cipher-algorithms | -digest-algorithms | -mac-algorithms | -public-key-algorithms

openssl no-XXX [ options ]

# DESCRIPTION

OpenSSL is a cryptography toolkit implementing the Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1) network protocols and related cryptography standards required by them.

The openssl program is a command line tool for using the various cryptography functions of OpenSSL's crypto library from the shell. It can be used for

     o  Creation and management of private keys, public keys and parameters
     o  Public key cryptographic operations
     o  Creation of X.509 certificates, CSRs and CRLs
     o  Calculation of Message Digests and Message Authentication Codes
     o  Encryption and Decryption with Ciphers
     o  SSL/TLS Client and Server Tests
     o  Handling of S/MIME signed or encrypted mail
     o  Timestamp requests, generation and verification

# COMMAND SUMMARY

The openssl program provides a rich variety of commands (command in the SYNOPSIS above). Each command can have many options and argument parameters, shown above as options and parameters.

Detailed documentation and use cases for most standard subcommands are available (e.g., openssl-x509(1)).

Many commands use an external configuration file for some or all of their arguments and have a -config option to specify that file. The default name of the file is openssl.cnf in the default certificate storage area, which can be determined from the openssl-version(1) command. The environment variable OPENSSL_CONF can be used to specify a different location of the file. See openssl-env(7).

The list options -standard-commands, -digest-commands, and -cipher-commands output a list (one entry per line) of the names of all standard commands, message digest commands, or cipher commands, respectively, that are available.

The list parameters -cipher-algorithms, -digest-algorithms, and -mac-algorithms list all cipher, message digest, and message authentication code names, one entry per line. Aliases are listed as:

     from => to

The list parameter -public-key-algorithms lists all supported public key algorithms.

The command no-XXX tests whether a command of the specified name is available. If no command named XXX exists, it returns 0 (success) and prints no-XXX; otherwise it returns 1 and prints XXX. In both cases, the output goes to stdout and nothing is printed to stderr. Additional command line arguments are always ignored. Since for each cipher there is a command of the same name, this provides an easy way for shell scripts to test for the availability of ciphers in the openssl program. (no-XXX is not able to detect pseudo-commands such as quit, list, or no-XXX itself.)

## Standard Commands

asn1parse

  Parse an ASN.1 sequence.

ca

  Certificate Authority (CA) Management.

ciphers

  Cipher Suite Description Determination.

cms

  CMS (Cryptographic Message Syntax) utility.

crl

  Certificate Revocation List (CRL) Management.

crl2pkcs7

  CRL to PKCS#7 Conversion.

dgst

  Message Digest calculation. MAC calculations are superseded by openssl-mac(1).

dhparam

  Generation and Management of Diffie-Hellman Parameters. Superseded by openssl-genpkey(1) and openssl-pkeyparam(1).

dsa

  DSA Data Management.

dsaparam

  DSA Parameter Generation and Management. Superseded by openssl-genpkey(1) and openssl-pkeyparam(1).

ec

  EC (Elliptic curve) key processing.

ecparam

  EC parameter manipulation and generation.

enc

  Encryption, decryption, and encoding.

engine

  Engine (loadable module) information and manipulation.

errstr

  Error Number to Error String Conversion.

fipsinstall

  FIPS configuration installation.

gendsa

  Generation of DSA Private Key from Parameters. Superseded by openssl-genpkey(1) and openssl-pkey(1).

genpkey

  Generation of Private Key or Parameters.

genrsa

  Generation of RSA Private Key. Superseded by openssl-genpkey(1).

help

  Display information about a command's options.

info

  Display diverse information built into the OpenSSL libraries.

kdf

  Key Derivation Functions.

list

  List algorithms and features.

mac

  Message Authentication Code Calculation.

nseq

  Create or examine a Netscape certificate sequence.

ocsp

  Online Certificate Status Protocol utility.

passwd

  Generation of hashed passwords.

pkcs12

  PKCS#12 Data Management.

pkcs7

  PKCS#7 Data Management.

pkcs8

  PKCS#8 format private key conversion tool.

pkey

  Public and private key management.

pkeyparam

  Public key algorithm parameter management.

pkeyutl

  Public key algorithm cryptographic operation utility.

prime

  Compute prime numbers.

provider

  Load and query providers.

rand

  Generate pseudo-random bytes.

rehash

  Create symbolic links to certificate and CRL files named by the hash values.

req

  PKCS#10 X.509 Certificate Signing Request (CSR) Management.

rsa

  RSA key management.

rsautl

  RSA utility for signing, verification, encryption, and decryption. Superseded by openssl-pkeyutl(1).

s_client

  This implements a generic SSL/TLS client which can establish a transparent connection to a remote server speaking SSL/TLS. It's intended for testing purposes only and provides only rudimentary interface functionality but internally uses mostly all functionality of the OpenSSL ssl library.

s_server

  This implements a generic SSL/TLS server which accepts connections from remote clients speaking SSL/TLS. It's intended for testing purposes only and provides only rudimentary interface functionality but internally uses mostly all functionality of the OpenSSL ssl library. It provides both an own command line oriented protocol for testing SSL functions and a simple HTTP response facility to emulate an SSL/TLS-aware webserver.

s_time

  SSL Connection Timer.

sess_id

  SSL Session Data Management.

smime

  S/MIME mail processing.

speed

  Algorithm Speed Measurement.

spkac

  SPKAC printing and generating utility.

srp

  Maintain SRP password file.

storeutl

  Utility to list and display certificates, keys, CRLs, etc.

ts

  Time Stamping Authority tool (client/server).

verify

  X.509 Certificate Verification.

version

  OpenSSL Version Information.

x509

  X.509 Certificate Data Management.

## Message Digest Commands

blake2b512

  BLAKE2b-512 Digest

blake2s256

  BLAKE2s-256 Digest

md2

  MD2 Digest

md4

  MD4 Digest

md5

  MD5 Digest

mdc2

  MDC2 Digest

rmd160

  RMD-160 Digest

sha1

  SHA-1 Digest

sha224

  SHA-2 224 Digest

sha256

  SHA-2 256 Digest

sha384

  SHA-2 384 Digest

sha512

  SHA-2 512 Digest

sha3-224

  SHA-3 224 Digest

sha3-256

  SHA-3 256 Digest

sha3-384

  SHA-3 384 Digest

sha3-512

  SHA-3 512 Digest

shake128

  SHA-3 SHAKE128 Digest

shake256

  SHA-3 SHAKE256 Digest

sm3

  SM3 Digest

## Encryption, Decryption, and Encoding Commands

The following aliases provide convenient access to the most used encodings and ciphers.

Depending on how OpenSSL was configured and built, not all ciphers listed here may be present. See openssl-enc(1) for more information.

aes128, aes-128-cbc, aes-128-cfb, aes-128-ctr, aes-128-ecb, aes-128-ofb

  AES-128 Cipher

aes192, aes-192-cbc, aes-192-cfb, aes-192-ctr, aes-192-ecb, aes-192-ofb

  AES-192 Cipher

aes256, aes-256-cbc, aes-256-cfb, aes-256-ctr, aes-256-ecb, aes-256-ofb

  AES-256 Cipher

aria128, aria-128-cbc, aria-128-cfb, aria-128-ctr, aria-128-ecb, aria-128-ofb

  Aria-128 Cipher

aria192, aria-192-cbc, aria-192-cfb, aria-192-ctr, aria-192-ecb, aria-192-ofb

  Aria-192 Cipher

aria256, aria-256-cbc, aria-256-cfb, aria-256-ctr, aria-256-ecb, aria-256-ofb

  Aria-256 Cipher

base64

  Base64 Encoding

bf, bf-cbc, bf-cfb, bf-ecb, bf-ofb

  Blowfish Cipher

camellia128, camellia-128-cbc, camellia-128-cfb, camellia-128-ctr, camellia-128-ecb, camellia-128-ofb

  Camellia-128 Cipher

camellia192, camellia-192-cbc, camellia-192-cfb, camellia-192-ctr, camellia-192-ecb, camellia-192-ofb

  Camellia-192 Cipher

camellia256, camellia-256-cbc, camellia-256-cfb, camellia-256-ctr, camellia-256-ecb, camellia-256-ofb

  Camellia-256 Cipher

cast, cast-cbc

  CAST Cipher

cast5-cbc, cast5-cfb, cast5-ecb, cast5-ofb

  CAST5 Cipher

chacha20

  Chacha20 Cipher

des, des-cbc, des-cfb, des-ecb, des-ede, des-ede-cbc, des-ede-cfb, des-ede-ofb, des-ofb

  DES Cipher

des3, desx, des-ede3, des-ede3-cbc, des-ede3-cfb, des-ede3-ofb

  Triple-DES Cipher

idea, idea-cbc, idea-cfb, idea-ecb, idea-ofb

  IDEA Cipher

rc2, rc2-cbc, rc2-cfb, rc2-ecb, rc2-ofb

  RC2 Cipher

rc4

  RC4 Cipher

rc5, rc5-cbc, rc5-cfb, rc5-ecb, rc5-ofb

  RC5 Cipher

seed, seed-cbc, seed-cfb, seed-ecb, seed-ofb

  SEED Cipher

sm4, sm4-cbc, sm4-cfb, sm4-ctr, sm4-ecb, sm4-ofb

  SM4 Cipher

# OPTIONS

Details of which options are available depend on the specific command. This section describes some common options with common behavior.

## Common Options

-help

  Provides a terse summary of all options. If an option takes an argument, the "type" of argument is also given.

--

  This terminates the list of options. It is mostly useful if any filename parameters start with a minus sign:

       openssl verify [flags...] -- -cert1.pem...

## Format Options

Several OpenSSL commands can take input or generate output in a variety of formats. The list of acceptable formats, and the default, is described in each command documentation. The list of formats is described below. Both uppercase and lowercase are accepted.

DER

  A binary format, encoded or parsed according to Distinguished Encoding Rules (DER) of the ASN.1 data language.

ENGINE

  Used to specify that the cryptographic material is in an OpenSSL engine. An engine must be configured or specified using the -engine option. In addition, the -input flag can be used to name a specific object in the engine. A password, such as the -passin flag often must be specified as well.

P12

  A DER-encoded file containing a PKCS#12 object. It might be necessary to provide a decryption password to retrieve the private key.

PEM

  A text format defined in IETF RFC 1421 and IETF RFC 7468. Briefly, this is a block of base-64 encoding (defined in IETF RFC 4648), with specific lines used to mark the start and end:

       Text before the BEGIN line is ignored.
       ----- BEGIN object-type -----
       OT43gQKBgQC/2OHZoko6iRlNOAQ/tMVFNq7fL81GivoQ9F1U0Qr+DH3ZfaH8eIkX
       xT0ToMPJUzWAn8pZv0snA0um6SIgvkCuxO84OkANCVbttzXImIsL7pFzfcwV/ERK
       UM6j0ZuSMFOCr/lGPAoOQU0fskidGEHi1/kW+suSr28TqsyYZpwBDQ==
       ----- END object-type -----
       Text after the END line is also ignored

  The object-type must match the type of object that is expected. For example a `BEGIN X509 CERTIFICATE` will not match if the command is trying to read a private key. The types supported include:

       ANY PRIVATE KEY
       CERTIFICATE
       CERTIFICATE REQUEST
       CMS
       DH PARAMETERS
       DSA PARAMETERS
       DSA PUBLIC KEY
       EC PARAMETERS
       EC PRIVATE KEY
       ECDSA PUBLIC KEY
       ENCRYPTED PRIVATE KEY
       PARAMETERS
       PKCS #7 SIGNED DATA
       PKCS7
       PRIVATE KEY
       PUBLIC KEY
       RSA PRIVATE KEY
       SSL SESSION PARAMETERS
       TRUSTED CERTIFICATE
       X509 CRL
       X9.42 DH PARAMETERS

  The following legacy object-type's are also supported for compatibility with earlier releases:

       DSA PRIVATE KEY
       NEW CERTIFICATE REQUEST
       RSA PUBLIC KEY
       X509 CERTIFICATE

SMIME

  An S/MIME object as described in IETF RFC 8551. Earlier versions were known as CMS and are compatible. Note that the parsing is simple and might fail to parse some legal data.

The options to specify the format are as follows. Refer to the individual manpage to see which options are accepted.

-inform format, -outform format

  The format of the input or output streams.

-keyform format

  Format of a private key input source.

-CRLform format

  Format of a CRL input source.

## Pass Phrase Options

Several commands accept password arguments, typically using -passin and -passout for input and output passwords respectively. These allow the password to be obtained from a variety of sources. Both of these options take a single argument whose format is described below. If no password argument is given and a password is required then the user is prompted to enter one: this will typically be read from the current terminal with echoing turned off.

Note that character encoding may be relevant, please see passphrase-encoding(7).

pass:password

  The actual password is password. Since the password is visible to utilities (like 'ps' under Unix) this form should only be used where security is not important.

env:var

  Obtain the password from the environment variable var. Since the environment of other processes is visible on certain platforms (e.g. ps under certain Unix OSes) this option should be used with caution.

file:pathname

  The first line of pathname is the password. If the same pathname argument is supplied to -passin and -passout arguments then the first line will be used for the input password and the next line for the output password. pathname need not refer to a regular file: it could for example refer to a device or named pipe.

fd:number

  Read the password from the file descriptor number. This can be used to send the data via a pipe for example.

stdin

  Read the password from standard input.

## Trusted Certificate Options

Part of validating a certificate includes verifying that the chain of CA's can be traced up to an existing trusted root. The following options specify how to list the trusted roots, also known as trust anchors. A collection of trusted roots is called a trust store.

Note that OpenSSL does not provide a default set of trust anchors. Many Linux distributions include a system default and configure OpenSSL to point to that. Mozilla maintains an influential trust store that can be found at https://www.mozilla.org/en-US/about/governance/policies/security-group/certs/.

-CAfile file

  Load the specified file which contains one or more PEM-format certificates of CA's that are trusted.

-no-CAfile

  Do not load the default file of trusted certificates.

-CApath dir

  Use the specified directory as a list of trust certificates. That is, files should be named with the hash of the X.509 SubjectName of each certificate. This is so that the library can extract the IssuerName, hash it, and directly lookup the file to get the issuer certificate. See openssl-rehash(1) for information on creating this type of directory.

-no-CApath

  Do not use the default directory of trusted certificates.

-CAstore uri

  Use uri as a store of trusted CA certificates. The URI may indicate a single certificate, as well as a collection of them. With URIs in the `file:` scheme, this acts as -CAfile or -CApath, depending on if the URI indicates a single file or directory. See ossl_store-file(7) for more information on the `file:` scheme.

  These certificates are also used when building the server certificate chain (for example with openssl-s_server(1)) or client certificate chain (for example with openssl-s_time(1)).

-no-CAstore

  Do not use the default store.

## Random State Options

Prior to OpenSSL 3.0, it was common for applications to store information about the state of the random-number generator in a file that was loaded at startup and rewritten upon exit. On modern operating systems, this is generally no longer necessary as OpenSSL will seed itself from the appropriate CPU flags, device files, and so on. These flags are still supported for special platforms or circumstances that might require them.

It is generally an error to use the same seed file more than once and every use of -rand should be paired with -writerand.

-rand files

  A file or files containing random data used to seed the random number generator. Multiple files can be specified separated by an OS-dependent character. The separator is `;` for MS-Windows, `,` for OpenVMS, and `:` for all others. Another way to specify multiple files is to repeat this flag with different filenames.

-writerand file

  Writes the seed data to the specified file upon exit. This file can be used in a subsequent command invocation.

## Extended Verification Options

Sometimes there may be more than one certificate chain leading to an end-entity certificate. This usually happens when a root or intermediate CA signs a certificate for another a CA in other organization. Another reason is when a CA might have intermediates that use two different signature formats, such as a SHA-1 and a SHA-256 digest.

The following options can be used to provide data that will allow the OpenSSL command to generate an alternative chain.

-xchain_build

  Specify whether the application should build the certificate chain to be provided to the server for the extra certificates via the -xkey, -xcert, and -xchain options.

-xkey infile, -xcert infile, -xchain

  Specify an extra certificate, private key and certificate chain. These behave in the same manner as the -cert, -key and -cert_chain options. When specified, the callback returning the first valid chain will be in use by the client.

-xcertform DER|PEM, -xkeyform DER|PEM

  The input format for the extra certificate and key, respectively. See openssl(1)/Format Options for details.

-xchain_build

  Specify whether the application should build the certificate chain to be provided to the server for the extra certificates via the -xkey, -xcert, and -xchain options.

-xcertform DER|PEM, -xkeyform DER|PEM

  The input format for the extra certificate and key, respectively. See openssl(1)/Format Options for details.

## Verification Options

Many OpenSSL commands verify certificates. The details of how each command handles errors are documented on the specific command page.

Verification is a complicated process, consisting of a number of separate steps that are detailed in the following paragraphs.

First, a certificate chain is built up starting from the supplied certificate and ending in a root CA. It is an error if the whole chain cannot be built up. The chain is built up by looking up the certificate that signed (or issued) the certificate. It then repeats the process, until it gets to a certificate that is self-issued.

The process of looking up the issuer's certificate itself involves a number of steps. After all certificates whose subject name matches the issuer name of the current certificate are subject to further tests. The relevant authority key identifier components of the current certificate (if present) must match the subject key identifier (if present) and issuer and serial number of the candidate issuer, in addition the keyUsage extension of the candidate issuer (if present) must permit certificate signing.

The lookup first looks in the list of untrusted certificates and if no match is found the remaining lookups are from the trusted certificates. The root CA is always looked up in the trusted certificate list: if the certificate to verify is a root certificate then an exact match must be found in the trusted list.

The second step is to check every untrusted certificate's extensions for consistency with the supplied purpose. If the -purpose option is not included then no checks are done. The supplied or "leaf" certificate must have extensions compatible with the supplied purpose and all other certificates must also be valid CA certificates. The precise extensions required are described in more detail in openssl-x509(1)/CERTIFICATE EXTENSIONS.

The third step is to check the trust settings on the root CA. The root CA should be trusted for the supplied purpose. For compatibility with previous versions of OpenSSL, a certificate with no trust settings is considered to be valid for all purposes.

The fourth, and final, step is to check the validity of the certificate chain. The validity period is checked against the system time and the `notBefore` and `notAfter` dates in the certificate. The certificate signatures are also checked at this point. The -attime flag may be used to specify a time other than "now."

If all operations complete successfully then certificate is considered valid. If any operation fails then the certificate is not valid.

The details of the processing steps can be fine-tuned with the following flags.

-verbose

  Print extra information about the operations being performed.

-attime timestamp

  Perform validation checks using time specified by timestamp and not current system time. timestamp is the number of seconds since January 1, 1970 (i.e., the Unix Epoch).

-no_check_time

  This option suppresses checking the validity period of certificates and CRLs against the current time. If option -attime is used to specify a verification time, the check is not suppressed.

-x509_strict

  This disables non-compliant workarounds for broken certificates.

-ignore_critical

  Normally if an unhandled critical extension is present which is not supported by OpenSSL the certificate is rejected (as required by RFC5280). If this option is set critical extensions are ignored.

-issuer_checks

  Ignored.

-crl_check

  Checks end entity certificate validity by attempting to look up a valid CRL. If a valid CRL cannot be found an error occurs.

-crl_check_all

  Checks the validity of all certificates in the chain by attempting to look up valid CRLs.

-use_deltas

  Enable support for delta CRLs.

-extended_crl

  Enable extended CRL features such as indirect CRLs and alternate CRL signing keys.

-suiteB_128_only, -suiteB_128, -suiteB_192

  Enable the Suite B mode operation at 128 bit Level of Security, 128 bit or 192 bit, or only 192 bit Level of Security respectively. See RFC6460 for details. In particular the supported signature algorithms are reduced to support only ECDSA and SHA256 or SHA384 and only the elliptic curves P-256 and P-384.

-auth_level level

  Set the certificate chain authentication security level to level. The authentication security level determines the acceptable signature and public key strength when verifying certificate chains. For a certificate chain to validate, the public keys of all the certificates must meet the specified security level. The signature algorithm security level is enforced for all the certificates in the chain except for the chain's trust anchor, which is either directly trusted or validated by means other than its signature. See SSL_CTX_set_security_level(3) for the definitions of the available levels. The default security level is -1, or "not set". At security level 0 or lower all algorithms are acceptable. Security level 1 requires at least 80-bit-equivalent security and is broadly interoperable, though it will, for example, reject MD5 signatures or RSA keys shorter than 1024 bits.

-partial_chain

  Allow verification to succeed even if a complete chain cannot be built to a self-signed trust-anchor, provided it is possible to construct a chain to a trusted certificate that might not be self-signed.

-check_ss_sig

  Verify the signature on the self-signed root CA. This is disabled by default because it doesn't add any security.

-allow_proxy_certs

  Allow the verification of proxy certificates.

-trusted_first

  As of OpenSSL 1.1.0 this option is on by default and cannot be disabled.

-no_alt_chains

  As of OpenSSL 1.1.0, since -trusted_first always on, this option has no effect.

-trusted file

  Parse file as a set of one or more certificates in PEM format. All certificates must be self-signed, unless the -partial_chain option is specified. This option implies the -no-CAfile and -no-CApath options and it cannot be used with either the -CAfile or -CApath options, so only certificates in the file are trust anchors. This option may be used multiple times.

-untrusted file

  Parse file as a set of one or more certificates in PEM format. All certificates are untrusted certificates that may be used to construct a certificate chain from the subject certificate to a trust anchor. This option may be used multiple times.

-policy arg

  Enable policy processing and add arg to the user-initial-policy-set (see RFC5280). The policy arg can be an object name an OID in numeric form. This argument can appear more than once.

-explicit_policy

  Set policy variable require-explicit-policy (see RFC5280).

-policy_check

  Enables certificate policy processing.

-policy_print

  Print out diagnostics related to policy processing.

-inhibit_any

  Set policy variable inhibit-any-policy (see RFC5280).

-inhibit_map

  Set policy variable inhibit-policy-mapping (see RFC5280).

-purpose purpose

  The intended use for the certificate. If this option is not specified, this command will not consider certificate purpose during chain verification. Currently accepted uses are sslclient, sslserver, nssslserver, smimesign, smimeencrypt.

-verify_depth num

  Limit the certificate chain to num intermediate CA certificates. A maximal depth chain can have up to num+2 certificates, since neither the end-entity certificate nor the trust-anchor certificate count against the -verify_depth limit.

-verify_email email

  Verify if email matches the email address in Subject Alternative Name or the email in the subject Distinguished Name.

-verify_hostname hostname

  Verify if hostname matches DNS name in Subject Alternative Name or Common Name in the subject certificate.

-verify_ip ip

  Verify if ip matches the IP address in Subject Alternative Name of the subject certificate.

-verify_name name

  Use default verification policies like trust model and required certificate policies identified by name. The trust model determines which auxiliary trust or reject OIDs are applicable to verifying the given certificate chain. See the -addtrust and -addreject options for openssl-x509(1). Supported policy names include: default, pkcs7, smime_sign, ssl_client, ssl_server. These mimics the combinations of purpose and trust settings used in SSL, CMS and S/MIME. As of OpenSSL 1.1.0, the trust model is inferred from the purpose when not specified, so the -verify_name options are functionally equivalent to the corresponding -purpose settings.

## Name Format Options

OpenSSL provides fine-grain control over how the subject and issuer DN's are displayed. This is specified by using the -nameopt option, which takes a comma-separated list of options from the following set. An option may be preceded by a minus sign, `-`, to turn it off. The default value is `oneline`. The first four are the most commonly used.

compat

  Display the name using an old format from previous OpenSSL versions.

RFC2253

  Display the name using the format defined in RFC 2253. It is equivalent to esc_2253, esc_ctrl, esc_msb, utf8, dump_nostr, dump_unknown, dump_der, sep_comma_plus, dn_rev and sname.

oneline

  Display the name in one line, using a format that is more readable RFC 2253. It is equivalent to esc_2253, esc_ctrl, esc_msb, utf8, dump_nostr, dump_der, use_quote, sep_comma_plus_space, space_eq and sname options.

multiline

  Display the name using multiple lines. It is equivalent to esc_ctrl, esc_msb, sep_multiline, space_eq, lname and align.

esc_2253

  Escape the "special" characters in a field, as required by RFC 2253. That is, any of the characters `,+"<>;`, `#` at the beginning of a string and leading or trailing spaces.

esc_2254

  Escape the "special" characters in a field as required by RFC 2254 in a field. That is, the NUL character and and of `()*`.

esc_ctrl

  Escape non-printable ASCII characters, codes less than 0x20 (space) or greater than 0x7F (DELETE). They are displayed using RFC 2253 `\XX` notation where XX are the two hex digits representing the character value.

esc_msb

  Escape any characters with the most significant bit set, that is with values larger than 127, as described in esc_ctrl.

use_quote

  Escapes some characters by surrounding the entire string with quotation marks, `"`. Without this option, individual special characters are preceeded with a backslash character, `\`.

utf8

  Convert all strings to UTF-8 format first as required by RFC 2253. If the output device is UTF-8 compatible, then using this option (and not setting esc_msb) may give the correct display of multibyte characters. If this option is not set, then multibyte characters larger than 0xFF will be output as `\UXXXX` for 16 bits or `\WXXXXXXXX` for 32 bits. In addition, any UTF8Strings will be converted to their character form first.

ignore_type

  This option does not attempt to interpret multibyte characters in any way. That is, the content octets are merely dumped as though one octet represents each character. This is useful for diagnostic purposes but will result in rather odd looking output.

show_type

  Display the type of the ASN1 character string before the value, such as `BMPSTRING: Hello World`.

dump_der

  Any fields that would be output in hex format are displayed using the DER encoding of the field. If not set, just the content octets are displayed. Either way, the #XXXX... format of RFC 2253 is used.

dump_nostr

  Dump non-character strings, such as ASN.1 OCTET STRING. If this option is not set, then non character string types will be displayed as though each content octet represents a single character.

dump_all

  Dump all fields. When this used with dump_der, this allows the DER encoding of the structure to be unambiguously determined.

dump_unknown

  Dump any field whose OID is not recognised by OpenSSL.

sep_comma_plus, sep_comma_plus_space, sep_semi_plus_space, sep_multiline

  Specify the field separators. The first word is used between the Relative Distinguished Names (RDNs) and the second is between multiple Attribute Value Assertions (AVAs). Multiple AVAs are very rare and their use is discouraged. The options ending in "space" additionally place a space after the separator to make it more readable. The sep_multiline starts each field on its own line, and uses "plus space" for the AVA separator. It also indents the fields by four characters. The default value is sep_comma_plus_space.

dn_rev

  Reverse the fields of the DN as required by RFC 2253. This also reverses the order of multiple AVAs in a field, but this is permissible as there is no ordering on values.

nofname, sname, lname, oid

  Specify how the field name is displayed. nofname does not display the field at all. sname uses the "short name" form (CN for commonName for example). lname uses the long form. oid represents the OID in numerical form and is useful for diagnostic purpose.

align

  Align field values for a more readable output. Only usable with sep_multiline.

space_eq

  Places spaces round the equal sign, `=`, character which follows the field name.

## TLS Version Options

Several commands use SSL, TLS, or DTLS. By default, the commands use TLS and clients will offer the lowest and highest protocol version they support, and servers will pick the highest version that the client offers that is also supported by the server.

The options below can be used to limit which protocol versions are used, and whether TCP (SSL and TLS) or UDP (DTLS) is used. Note that not all protocols and flags may be available, depending on how OpenSSL was built.

-ssl3, -tls1, -tls1_1, -tls1_2, -tls1_3, -no_ssl3, -no_tls1, -no_tls1_1, -no_tls1_2, -no_tls1_3

  These options require or disable the use of the specified SSL or TLS protocols. When a specific TLS version is required, only that version will be offered or accepted. Only one specific protocol can be given and it cannot be combined with any of the no_ options.

-dtls, -dtls1, -dtls1_2

  These options specify to use DTLS instead of DLTS. With -dtls, clients will negotiate any supported DTLS protocol version. Use the -dtls1 or -dtls1_2 options to support only DTLS1.0 or DTLS1.2, respectively.

## Engine Options

-engine id

  Use the engine identified by id and use all the methods it implements (algorithms, key storage, etc.), unless specified otherwise in the command-specific documentation or it is configured to do so, as described in config(5)/Engine Configuration Module.

# ENVIRONMENT

The OpenSSL library can be take some configuration parameters from the environment. Some of these variables are listed below. For information about specific commands, see openssl-engine(1), openssl-provider(1), openssl-rehash(1), and tsget(1).

For information about the use of environment variables in configuration, see config(5)/ENVIRONMENT.

For information about querying or specifying CPU architecture flags, see OPENSSL_ia32cap(3), and OPENSSL_s390xcap(3).

For information about all environment variables used by the OpenSSL libraries, see openssl-env(7).

OPENSSL_TRACE=name[,...]

  Enable tracing output of OpenSSL library, by name. This output will only make sense if you know OpenSSL internals well. Also, it might not give you any output at all, depending on how OpenSSL was built.

  The value is a comma separated list of names, with the following available:

  TRACE

    The tracing functionality.

  TLS

    General SSL/TLS.

  TLS_CIPHER

    SSL/TLS cipher.

  ENGINE_CONF

    ENGINE configuration.

  ENGINE_TABLE

    The function that is used by RSA, DSA (etc) code to select registered ENGINEs, cache defaults and functional references (etc), will generate debugging summaries.

  ENGINE_REF_COUNT

    Reference counts in the ENGINE structure will be monitored with a line of generated for each change.

  PKCS5V2

    PKCS#5 v2 keygen.

  PKCS12_KEYGEN

    PKCS#12 key generation.

  PKCS12_DECRYPT

    PKCS#12 decryption.

  X509V3_POLICY

    Generates the complete policy tree at various point during X.509 v3 policy evaluation.

  BN_CTX

    BIGNUM context.

# SEE ALSO

openssl-asn1parse(1), openssl-ca(1), openssl-ciphers(1), openssl-cms(1), openssl-crl(1), openssl-crl2pkcs7(1), openssl-dgst(1), openssl-dhparam(1), openssl-dsa(1), openssl-dsaparam(1), openssl-ec(1), openssl-ecparam(1), openssl-enc(1), openssl-engine(1), openssl-errstr(1), openssl-gendsa(1), openssl-genpkey(1), openssl-genrsa(1), openssl-kdf(1), openssl-mac(1), openssl-nseq(1), openssl-ocsp(1), openssl-passwd(1), openssl-pkcs12(1), openssl-pkcs7(1), openssl-pkcs8(1), openssl-pkey(1), openssl-pkeyparam(1), openssl-pkeyutl(1), openssl-prime(1), openssl-rand(1), openssl-rehash(1), openssl-req(1), openssl-rsa(1), openssl-rsautl(1), openssl-s_client(1), openssl-s_server(1), openssl-s_time(1), openssl-sess_id(1), openssl-smime(1), openssl-speed(1), openssl-spkac(1), openssl-srp(1), openssl-storeutl(1), openssl-ts(1), openssl-verify(1), openssl-version(1), openssl-x509(1), config(5), crypto(7), openssl-env(7). ssl(7), x509v3_config(5)

# HISTORY

The list -XXX-algorithms options were added in OpenSSL 1.0.0; For notes on the availability of other commands, see their individual manual pages.

The -issuer_checks option is deprecated as of OpenSSL 1.1.0 and is silently ignored.

# COPYRIGHT

Copyright 2000-2019 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.